#include <GDIPlus.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <GDIPlus.au3>
#include <GUIConstantsEx.au3>
#include <GDIPlus.au3>
#include <Bass.au3>
#include <BassConstants.au3>
#include <BassTags.au3>

Opt("GUIOnEventMode", 1)

Global $iWidth = @DesktopWidth, $iHeight = @DesktopHeight
;Global $iWidth=800, $iHeight=500
Global $iAmplitude = $iHeight / 2
Global $iYOffset = $iHeight * 0.5
Global $iDistance = $iHeight / 60
Global $iHzXOff = $iWidth / 512, $iHzYOff = $iHeight / 60
Global $iMeterH = $iHeight / 100


_BASS_STARTUP(@ScriptDir & '\BASS.dll')
_Bass_Tags_Startup('BassTags.dll')
_BASS_Init(0, -1, 44100, 0, '')
If @error Then
	MsgBox(0, 'Error', 'Sound konnte nicht Initialisiert werden!')
	Exit
EndIf
Global $File = FileOpenDialog('Bitte whlen Sie eine Sounddatei aus!', '', 'MP3 Datei (*.mp3;*.wav)')
If @error Then
	MsgBox(0, 'Fehler', 'Die Datei ist ungltig!' & @LF & 'Das Programm wird beendet!')
	Exit
EndIf
Global $hMusicHandle = _BASS_StreamCreateFile(False, $File, 0, 0, 0)
Global $ID3Album = _Bass_Tags_Read($hMusicHandle, '%IFV1(%ALBM,%IUPC(%ALBM))')
If @error Then
	Exit
EndIf
Global $ID3Title = _Bass_Tags_Read($hMusicHandle, '%IFV1(%TRCK,%TRCK. )%IFV2(%ARTI,%ICAP(%ARTI), Nichts) - %IFV2(%TITL,%ICAP(%TITL) , Nichts )')
If @error Then
	Exit
EndIf


Global $aPoints[514][2]
For $i = 0 To 513
	$aPoints[$i][1] = $iAmplitude
	$aPoints[$i][0] = (($iWidth - 200) * (Log($i) / Log(10) * 20)) / 54.1853992195166 + 100
Next
$aPoints[0][0] = 513
$aPoints[512][1] = $iAmplitude - 1
$aPoints[513][0] = 0

Global $hGui = GUICreate("Spectrum", $iWidth, $iHeight, 0, 0, $WS_POPUP, $WS_EX_TOPMOST)
GUISetOnEvent($GUI_EVENT_CLOSE, "_Exit")
GUISetBkColor(0x000000)
If @OSVersion = "WIN_XP" Then WinSetTrans($hGui, "", 0xFF)
_GDIPlus_Startup()
Global $hGraphics = _GDIPlus_GraphicsCreateFromHWND($hGui)
_GDIPlus_GraphicsClear($hGraphics, 0xFF000000)
Global $hBitmap = _GDIPlus_BitmapCreateFromGraphics($iWidth, $iHeight, $hGraphics)
Global $hContext = _GDIPlus_ImageGetGraphicsContext($hBitmap)

Global $hBitmapMeter = _CreateMeterBmp($hGraphics)

Global $hBitmapHz = _CreateHzBmp($hGraphics, $iWidth, "Arial", $iHeight / 100), $iFontHz
$iFontHz = @extended
Global $iBitmapHzH = _GDIPlus_ImageGetHeight($hBitmapHz)

Global $hBrushVerlauf = _GDIPlus_LineBrushCreate(0, $iYOffset - $iHeight / 6, 0, $iYOffset - $iHeight / 6 + $iHeight / 20, 0xFF000000, 0xFF888888)
Global $hBrushBk = _GDIPlus_BrushCreateSolid(0xFF888888)
Global $hBrushFFT = _GDIPlus_BrushCreateSolid(0xFFFFFFFF)
Global $hBrushMirror = _GDIPlus_BrushCreateSolid(0xEE000000)
Global $hBrushTitle = _GDIPlus_BrushCreateSolid(0xFFFFAA00)
Global $hBrushAlbum = _GDIPlus_BrushCreateSolid(0xFFFFAA00)
Global $hPenMeter = _GDIPlus_PenCreate(0xFFFFFFFF, 2, 2)


Global $hBitmapTitle = _CreateTextBmp($hGraphics, StringUpper($ID3Title), "Arial", $iHeight / 60, $hBrushTitle), $iFontTitle
$iFontTitle = @extended
Global $iBitmapTitleH = _GDIPlus_ImageGetHeight($hBitmapTitle)

Global $hBitmapAlbum = _CreateTextBmp($hGraphics, StringUpper($ID3Album), "Arial", $iHeight / 80, $hBrushAlbum), $iFontAlbum
$iFontAlbum = @extended
Global $iBitmapAlbumH = _GDIPlus_ImageGetHeight($hBitmapAlbum)

GUISetState()


Global $fftstruct = DllStructCreate('float[512]')
_BASS_ChannelPlay($hMusicHandle, 0)


;GUIRegisterMsg($WM_ERASEBKGND, "_WM_ERASEBKGND")
;GUIRegisterMsg($WM_PAINT, "_WM_PAINT")

Global $iTimer = TimerInit()
While 1
	If TimerDiff($iTimer) > 75 Then
		$iTimer = TimerInit()
		_Draw()
	EndIf
WEnd

Func _Draw()
	;Local $iTimer=TimerInit()
	Local $nLevel, $iTemp
	Local $hBitmapTemp = _GDIPlus_BitmapCreateFromGraphics($iWidth, $iAmplitude, $hGraphics)
	Local $hGraphicsTemp = _GDIPlus_ImageGetGraphicsContext($hBitmapTemp)
	Local Static $nLL = 0, $nLR = 0
	_GDIPlus_GraphicsSetSmoothingMode($hContext, 1)
	_GDIPlus_GraphicsClear($hContext, 0xFF000000)
	_GDIPlus_GraphicsFillRect($hContext, 0, $iYOffset - $iHeight / 6 + 1, $iWidth, $iHeight / 20, $hBrushVerlauf)
	_GDIPlus_GraphicsFillRect($hContext, 0, $iYOffset - $iHeight / 6 + $iHeight / 20, $iWidth, $iHeight, $hBrushBk)

	_BASS_ChannelGetData($hMusicHandle, DllStructGetPtr($fftstruct), $BASS_DATA_FFT1024)

	For $i = 1 To 512
		Switch $i
			Case 0 To 4
				$nLevel = _DecibelFloat(DllStructGetData($fftstruct, 1, $i)) * $iAmplitude * 0.7
			Case 5 To 90
				$nLevel = _DecibelFloat(DllStructGetData($fftstruct, 1, $i)) * $iAmplitude
			Case Else
				$nLevel = _DecibelFloat(DllStructGetData($fftstruct, 1, $i)) * $iAmplitude * 0.8
		EndSwitch
		$nLevel = $iAmplitude - $nLevel
		$aPoints[$i][1] += ($nLevel - $aPoints[$i][1]) / 2
		If $nLevel < $aPoints[$i][1] Then $aPoints[$i][1] = $nLevel
		Switch $i
			Case 125 To 512
				$iTemp = Ceiling(Log($i) / Log(5) * 5) - 14
				For $j = 0 To $iTemp
					If $i + $j > 512 Then ExitLoop 2
					$aPoints[$i + $j][0] = $aPoints[$i][0]
					$aPoints[$i + $j][1] = $aPoints[$i][1]
				Next
				$i += $iTemp
		EndSwitch
	Next
	$aPoints[1][1] = $iAmplitude - 1
	$aPoints[513][0] = $aPoints[513][0]

	$nLL -= 0.03
	$nLR -= 0.03
	$nLevel = _BASS_ChannelGetLevel($hMusicHandle)
	$iTemp = _DecibelFloat(_LoWord($nLevel) / 32768)
	If $iTemp > $nLL Then $nLL = $iTemp
	$iTemp = _DecibelFloat(_HiWord($nLevel) / 32768)
	If $iTemp > $nLR Then $nLR = $iTemp

	Local $iTM = 18, $iTA = 14, $iMM = 6

	_GDIPlus_GraphicsFillClosedCurve($hGraphicsTemp, $aPoints, $hBrushFFT)
	_GDIPlus_GraphicsFillRect($hGraphicsTemp, 80, $iAmplitude - 1, $iWidth - 160, 1, $hBrushFFT)

	_GDIPlus_DrawImagePoints($hContext, $hBitmapTemp, 0, $iYOffset + $iDistance + $iAmplitude, $iWidth, $iYOffset + $iDistance + $iAmplitude, 0, $iYOffset + $iDistance)
	_GDIPlus_DrawImagePoints($hContext, $hBitmapHz, $iHzXOff, $iYOffset + $iHzYOff + $iDistance + $iFontHz, $iWidth + $iHzXOff, $iYOffset + $iHzYOff + $iDistance + $iFontHz, $iHzXOff, $iYOffset + $iHzYOff + $iDistance + $iFontHz - $iBitmapHzH)
	_GDIPlus_DrawImagePoints($hContext, $hBitmapTitle, $iHzXOff * $iTM, $iYOffset + $iHzYOff * $iTM + $iDistance + $iFontTitle, $iWidth + $iHzXOff * $iTM, $iYOffset + $iHzYOff * $iTM + $iDistance + $iFontTitle, $iHzXOff * $iTM, $iYOffset + $iHzYOff * $iTM + $iDistance + $iFontTitle - $iBitmapTitleH)
	_GDIPlus_DrawImagePoints($hContext, $hBitmapAlbum, $iHzXOff * $iTA, $iYOffset + $iHzYOff * $iTA + $iDistance + $iFontAlbum, $iWidth + $iHzXOff * $iTA, $iYOffset + $iHzYOff * $iTA + $iDistance + $iFontAlbum, $iHzXOff * $iTA, $iYOffset + $iHzYOff * $iTA + $iDistance + $iFontAlbum - $iBitmapAlbumH)

	_GDIPlus_GraphicsDrawRect($hContext, 100 + $iHzXOff * $iMM, $iYOffset + $iHzYOff * $iMM + $iMeterH + $iDistance + 5, $iWidth - 200, $iMeterH, $hPenMeter)
	_GDIPlus_GraphicsDrawImageRectRect($hContext, $hBitmapMeter, 0, 0, ($iWidth - 200) * $nLR, $iMeterH, 100 + $iHzXOff * $iMM, $iYOffset + $iHzYOff * $iMM + $iMeterH + $iDistance + 5, ($iWidth - 200) * $nLR, $iMeterH)
	_GDIPlus_GraphicsDrawRect($hContext, 100 + $iHzXOff * $iMM, $iYOffset + $iHzYOff * $iMM + $iMeterH * 2 + $iDistance + $iMeterH * 0.3 + 7, $iWidth - 200, $iMeterH, $hPenMeter)
	_GDIPlus_GraphicsDrawImageRectRect($hContext, $hBitmapMeter, 0, 0, ($iWidth - 200) * $nLL, $iMeterH, 100 + $iHzXOff * $iMM, $iYOffset + $iHzYOff * $iMM + $iMeterH * 2 + $iDistance + $iMeterH * 0.3 + 7, ($iWidth - 200) * $nLL, $iMeterH)

	_GDIPlus_GraphicsFillRect($hContext, 0, 0, $iWidth, $iHeight, $hBrushMirror)

	_GDIPlus_GraphicsDrawRect($hContext, 100 + $iHzXOff * $iMM, $iYOffset + $iHzYOff * $iMM, $iWidth - 200, $iMeterH, $hPenMeter)
	_GDIPlus_GraphicsDrawImageRectRect($hContext, $hBitmapMeter, 0, 0, ($iWidth - 200) * $nLR, 10, 100 + $iHzXOff * $iMM, $iYOffset + $iHzYOff * $iMM, ($iWidth - 200) * $nLR, $iMeterH)
	_GDIPlus_GraphicsDrawRect($hContext, 100 + $iHzXOff * $iMM, $iYOffset + $iHzYOff * $iMM - $iMeterH - $iMeterH * 0.3 - 2, $iWidth - 200, $iMeterH, $hPenMeter)
	_GDIPlus_GraphicsDrawImageRectRect($hContext, $hBitmapMeter, 0, 0, ($iWidth - 200) * $nLL, 10, 100 + $iHzXOff * $iMM, $iYOffset + $iHzYOff * $iMM - $iMeterH - $iMeterH * 0.3 - 2, ($iWidth - 200) * $nLL, $iMeterH)

	_GDIPlus_GraphicsDrawImage($hContext, $hBitmapTemp, 0, $iYOffset - $iAmplitude)
	_GDIPlus_GraphicsDrawImage($hContext, $hBitmapHz, $iHzXOff, $iYOffset + $iHzYOff - $iFontHz)
	_GDIPlus_GraphicsDrawImage($hContext, $hBitmapTitle, $iHzXOff * $iTM, $iYOffset + $iHzYOff * $iTM - $iFontTitle)

	_GDIPlus_GraphicsDrawImage($hContext, $hBitmapAlbum, $iHzXOff * $iTA, $iYOffset + $iHzYOff * $iTA - $iFontAlbum)

	_GDIPlus_GraphicsDispose($hGraphicsTemp)
	_GDIPlus_BitmapDispose($hBitmapTemp)
	;_WinAPI_RedrawWindow($hGui)
	_GDIPlus_GraphicsDrawImage($hGraphics, $hBitmap, 0, 0)
	;ConsoleWrite(TimerDiff($iTimer) & @LF)
EndFunc   ;==>_Draw


Func _CreateMeterBmp($hGraphics)
	Local $hBrush[6], $iTile = ($iWidth - 200) / 12
	$hBrush[0] = _GDIPlus_BrushCreateSolid(0xFF00FF00)
	$hBrush[1] = _GDIPlus_LineBrushCreate($iTile * 6 - 1, 0, $iTile * 9, 0, 0xFF00FF00, 0xFFFFFF00)
	$hBrush[2] = _GDIPlus_BrushCreateSolid(0xFFFFFF00)
	$hBrush[3] = _GDIPlus_LineBrushCreate($iTile * 10 - 1, 0, $iTile * 11, 0, 0xFFFFFF00, 0xFFFF0000)
	$hBrush[4] = _GDIPlus_BrushCreateSolid(0xFFFF0000)
	$hBrush[5] = _GDIPlus_LineBrushCreate(0, 0, 4, 0, 0x00000000, 0x99000000)
	Local $hBitmap = _GDIPlus_BitmapCreateFromGraphics($iWidth - 200, 10, $hGraphics)
	Local $hContext = _GDIPlus_ImageGetGraphicsContext($hBitmap)
	_GDIPlus_GraphicsFillRect($hContext, 0, 0, $iTile * 8, 10, $hBrush[0])
	_GDIPlus_GraphicsFillRect($hContext, $iTile * 6, 0, $iTile * 3, 10, $hBrush[1])
	_GDIPlus_GraphicsFillRect($hContext, $iTile * 9, 0, $iTile, 10, $hBrush[2])
	_GDIPlus_GraphicsFillRect($hContext, $iTile * 10, 0, $iTile, 10, $hBrush[3])
	_GDIPlus_GraphicsFillRect($hContext, $iTile * 11, 0, $iTile, 10, $hBrush[4])
	For $i = 0 To $iWidth - 200 Step 4
		_GDIPlus_GraphicsFillRect($hContext, $i, 0, 4, 10, $hBrush[5])
	Next
	_GDIPlus_GraphicsDispose($hContext)
	For $i = 0 To 5
		_GDIPlus_BrushDispose($hBrush[$i])
	Next
	Return $hBitmap
EndFunc   ;==>_CreateMeterBmp


Func _CreateTextBmp($hGraphics, $sString, $sFont, $nSize, $hBrush)
	Local $iHeight
	Local $hBrushBk = _GDIPlus_BrushCreateSolid(0xFF000000)
	Local $hFormat = _GDIPlus_StringFormatCreate(0x0004)
	Local $hFamily = _GDIPlus_FontFamilyCreate($sFont)
	Local $hFont = _GDIPlus_FontCreate($hFamily, $nSize, 1)
	Local $tLayout, $aInfo
	$tLayout = _GDIPlus_RectFCreate(0, 0, 0, 0)
	$aInfo = _GDIPlus_GraphicsMeasureString($hGraphics, $sString, $hFont, $tLayout, $hFormat)
	$iHeight = DllStructGetData($aInfo[0], "Height")
	DllStructSetData($aInfo[0], "X", $iWidth / 2 - DllStructGetData($aInfo[0], "Width") / 2)
	Local $hBitmap = _GDIPlus_BitmapCreateFromGraphics($iWidth, $iHeight, $hGraphics)
	Local $hContext = _GDIPlus_ImageGetGraphicsContext($hBitmap)
	Local $iX = DllStructGetData($aInfo[0], "X")
	Local $iY = DllStructGetData($aInfo[0], "Y")
	For $x = -1 To 1
		For $y = -1 To 1
			DllStructSetData($aInfo[0], "X", $iX + $x)
			DllStructSetData($aInfo[0], "Y", $iY + $y)
			_GDIPlus_GraphicsDrawStringEx($hContext, $sString, $hFont, $aInfo[0], $hFormat, $hBrushBk)
		Next
	Next
	DllStructSetData($aInfo[0], "X", $iX)
	DllStructSetData($aInfo[0], "Y", $iY)
	_GDIPlus_GraphicsDrawStringEx($hContext, $sString, $hFont, $aInfo[0], $hFormat, $hBrush)
	_GDIPlus_BrushDispose($hBrushBk)
	_GDIPlus_FontDispose($hFont)
	_GDIPlus_FontFamilyDispose($hFamily)
	_GDIPlus_StringFormatDispose($hFormat)
	_GDIPlus_GraphicsDispose($hContext)
	For $y = $iHeight - 1 To 0 Step -1
		For $x = 100 To $iWidth - 100
			$Test = _GDIPlus_BitmapGetPixel($hBitmap, $x, $y)
			If $Test Then
				$iHeight = $y + 1
				ExitLoop 2
			EndIf
		Next
	Next
	Return SetExtended($iHeight, $hBitmap)
EndFunc   ;==>_CreateTextBmp



Func _CreateHzBmp($hGraphics, $iWidth, $sFont, $nSize)
	Local $iHeight
	Local $hBrush = _GDIPlus_BrushCreateSolid(0xFFFFAA00)
	Local $hBrushBk = _GDIPlus_BrushCreateSolid(0xFF000000)
	Local $hFormat = _GDIPlus_StringFormatCreate(0x0004)
	Local $hFamily = _GDIPlus_FontFamilyCreate($sFont)
	Local $hFont = _GDIPlus_FontCreate($hFamily, $nSize, 1)
	Local $tLayout, $aInfo
	$tLayout = _GDIPlus_RectFCreate(100, 0, 0, 0)
	$aInfo = _GDIPlus_GraphicsMeasureString($hGraphics, "Hz", $hFont, $tLayout, $hFormat)
	$iHeight = DllStructGetData($aInfo[0], "Height")
	Local $hBitmap = _GDIPlus_BitmapCreateFromGraphics($iWidth, $iHeight, $hGraphics)
	Local $hContext = _GDIPlus_ImageGetGraphicsContext($hBitmap)
	;_GDIPlus_GraphicsClear($hContext,0xFF00FF00)
	Local $aHz[10] = ["Hz", 40, 80, 160, 400, 1000, 2000, 4000, 8000, 16000], $iX, $iY
	For $i In $aHz
		Switch $i
			Case "Hz"
				$iX = 100
			Case Else
				$iX = ((($iWidth - 200) * (Log($i) / Log(10) * 20)) / 60.2059991327962) - ((($iWidth - 200) * (Log(20) / Log(10) * 20)) / 60.2059991327962) + 100
		EndSwitch
		$tLayout = _GDIPlus_RectFCreate($iX, 0, 0, 0)
		$aInfo = _GDIPlus_GraphicsMeasureString($hContext, StringReplace($i, "000", "k"), $hFont, $tLayout, $hFormat)
		DllStructSetData($aInfo[0], "X", $iX - DllStructGetData($aInfo[0], "Width") / 2)
		$iX = DllStructGetData($aInfo[0], "X")
		$iY = DllStructGetData($aInfo[0], "Y")
		For $x = -1 To 1
			For $y = -1 To 1
				DllStructSetData($aInfo[0], "X", $iX + $x)
				DllStructSetData($aInfo[0], "Y", $iY + $y)
				_GDIPlus_GraphicsDrawStringEx($hContext, StringReplace($i, "000", "k"), $hFont, $aInfo[0], $hFormat, $hBrushBk)
			Next
		Next
		DllStructSetData($aInfo[0], "X", $iX)
		DllStructSetData($aInfo[0], "Y", $iY)
		_GDIPlus_GraphicsDrawStringEx($hContext, StringReplace($i, "000", "k"), $hFont, $aInfo[0], $hFormat, $hBrush)
	Next
	_GDIPlus_BrushDispose($hBrush)
	_GDIPlus_BrushDispose($hBrushBk)
	_GDIPlus_FontDispose($hFont)
	_GDIPlus_FontFamilyDispose($hFamily)
	_GDIPlus_StringFormatDispose($hFormat)
	_GDIPlus_GraphicsDispose($hContext)
	For $y = $iHeight - 1 To 0 Step -1
		For $x = 100 To $iWidth - 100
			$Test = _GDIPlus_BitmapGetPixel($hBitmap, $x, $y)
			If $Test Then
				$iHeight = $y + 1
				ExitLoop 2
			EndIf
		Next
	Next
	Return SetExtended($iHeight, $hBitmap)
EndFunc   ;==>_CreateHzBmp

Func _GDIPlus_BitmapGetPixel($hBitmap, $x, $y)
	Local $result = DllCall($ghGDIPDll, "int", "GdipBitmapGetPixel", "ptr", $hBitmap, "int", $x, "int", $y, "dword*", 0)
	If @error Then Return SetError(1, 0, 0)
	Return SetError($result[0], 1, $result[4])
EndFunc   ;==>_GDIPlus_BitmapGetPixel


Func _DecibelFloat($iLevel)
	$iLevel = Log($iLevel) / Log(10) * 20
	If $iLevel < -64 Then $iLevel = -64
	$iLevel = ($iLevel + 64) / 64
	Return $iLevel
EndFunc   ;==>_DecibelFloat

Func _WM_PAINT($hWnd, $Msg, $wParam, $lParam)
	_GDIPlus_GraphicsDrawImage($hGraphics, $hBitmap, 0, 0)
EndFunc   ;==>_WM_PAINT

Func _WM_ERASEBKGND($hWnd, $Msg, $wParam, $lParam)
	_GDIPlus_GraphicsDrawImage($hGraphics, $hBitmap, 0, 0)
	Return True
EndFunc   ;==>_WM_ERASEBKGND


Func _GDIPlus_LineBrushCreate($nX1, $nY1, $nX2, $nY2, $iARGBClr1, $iARGBClr2, $iWrapMode = 0)
	Local $tPointF1, $pPointF1
	Local $tPointF2, $pPointF2
	Local $aResult
	$tPointF1 = DllStructCreate("float;float")
	$pPointF1 = DllStructGetPtr($tPointF1)
	$tPointF2 = DllStructCreate("float;float")
	$pPointF2 = DllStructGetPtr($tPointF2)
	DllStructSetData($tPointF1, 1, $nX1)
	DllStructSetData($tPointF1, 2, $nY1)
	DllStructSetData($tPointF2, 1, $nX2)
	DllStructSetData($tPointF2, 2, $nY2)
	$aResult = DllCall($ghGDIPDll, "uint", "GdipCreateLineBrush", "ptr", $pPointF1, "ptr", $pPointF2, "uint", $iARGBClr1, "uint", $iARGBClr2, "int", $iWrapMode, "int*", 0)
	If @error Then Return SetError(@error, @extended, 0)
	$GDIP_STATUS = $aResult[0]
	Return $aResult[6]
EndFunc   ;==>_GDIPlus_LineBrushCreate


Func _Exit()
	_BASS_Stop()
	_BASS_Free()
	_GDIPlus_PenDispose($hPenMeter)
	_GDIPlus_BrushDispose($hBrushAlbum)
	_GDIPlus_BrushDispose($hBrushTitle)
	_GDIPlus_BrushDispose($hBrushMirror)
	_GDIPlus_BrushDispose($hBrushFFT)
	_GDIPlus_BrushDispose($hBrushBk)
	_GDIPlus_BrushDispose($hBrushVerlauf)
	_GDIPlus_BitmapDispose($hBitmap)
	_GDIPlus_GraphicsDispose($hGraphics)
	_GDIPlus_Shutdown()
	Exit
EndFunc   ;==>_Exit